//
// This is a generated file, do not edit!
// Generated by R.swift, see https://github.com/mac-cain13/R.swift
//

import Foundation
import Rswift
import UIKit

/// This `R` struct is generated and contains references to static resources.
struct R: Rswift.Validatable {
  fileprivate static let applicationLocale = hostingBundle.preferredLocalizations.first.flatMap { Locale(identifier: $0) } ?? Locale.current
  fileprivate static let hostingBundle = Bundle(for: R.Class.self)

  /// Find first language and bundle for which the table exists
  fileprivate static func localeBundle(tableName: String, preferredLanguages: [String]) -> (Foundation.Locale, Foundation.Bundle)? {
    // Filter preferredLanguages to localizations, use first locale
    var languages = preferredLanguages
      .map { Locale(identifier: $0) }
      .prefix(1)
      .flatMap { locale -> [String] in
        if hostingBundle.localizations.contains(locale.identifier) {
          if let language = locale.languageCode, hostingBundle.localizations.contains(language) {
            return [locale.identifier, language]
          } else {
            return [locale.identifier]
          }
        } else if let language = locale.languageCode, hostingBundle.localizations.contains(language) {
          return [language]
        } else {
          return []
        }
      }

    // If there's no languages, use development language as backstop
    if languages.isEmpty {
      if let developmentLocalization = hostingBundle.developmentLocalization {
        languages = [developmentLocalization]
      }
    } else {
      // Insert Base as second item (between locale identifier and languageCode)
      languages.insert("Base", at: 1)

      // Add development language as backstop
      if let developmentLocalization = hostingBundle.developmentLocalization {
        languages.append(developmentLocalization)
      }
    }

    // Find first language for which table exists
    // Note: key might not exist in chosen language (in that case, key will be shown)
    for language in languages {
      if let lproj = hostingBundle.url(forResource: language, withExtension: "lproj"),
         let lbundle = Bundle(url: lproj)
      {
        let strings = lbundle.url(forResource: tableName, withExtension: "strings")
        let stringsdict = lbundle.url(forResource: tableName, withExtension: "stringsdict")

        if strings != nil || stringsdict != nil {
          return (Locale(identifier: language), lbundle)
        }
      }
    }

    // If table is available in main bundle, don't look for localized resources
    let strings = hostingBundle.url(forResource: tableName, withExtension: "strings", subdirectory: nil, localization: nil)
    let stringsdict = hostingBundle.url(forResource: tableName, withExtension: "stringsdict", subdirectory: nil, localization: nil)

    if strings != nil || stringsdict != nil {
      return (applicationLocale, hostingBundle)
    }

    // If table is not found for requested languages, key will be shown
    return nil
  }

  /// Load string from Info.plist file
  fileprivate static func infoPlistString(path: [String], key: String) -> String? {
    var dict = hostingBundle.infoDictionary
    for step in path {
      guard let obj = dict?[step] as? [String: Any] else { return nil }
      dict = obj
    }
    return dict?[key] as? String
  }

  static func validate() throws {
    try intern.validate()
  }

  #if os(iOS) || os(tvOS)
  /// This `R.storyboard` struct is generated, and contains static references to 2 storyboards.
  struct storyboard {
    /// Storyboard `LaunchScreen`.
    static let launchScreen = _R.storyboard.launchScreen()
    /// Storyboard `Main`.
    static let main = _R.storyboard.main()

    #if os(iOS) || os(tvOS)
    /// `UIStoryboard(name: "LaunchScreen", bundle: ...)`
    static func launchScreen(_: Void = ()) -> UIKit.UIStoryboard {
      return UIKit.UIStoryboard(resource: R.storyboard.launchScreen)
    }
    #endif

    #if os(iOS) || os(tvOS)
    /// `UIStoryboard(name: "Main", bundle: ...)`
    static func main(_: Void = ()) -> UIKit.UIStoryboard {
      return UIKit.UIStoryboard(resource: R.storyboard.main)
    }
    #endif

    fileprivate init() {}
  }
  #endif

  /// This `R.color` struct is generated, and contains static references to 1 colors.
  struct color {
    /// Color `AccentColor`.
    static let accentColor = Rswift.ColorResource(bundle: R.hostingBundle, name: "AccentColor")

    #if os(iOS) || os(tvOS)
    /// `UIColor(named: "AccentColor", bundle: ..., traitCollection: ...)`
    @available(tvOS 11.0, *)
    @available(iOS 11.0, *)
    static func accentColor(compatibleWith traitCollection: UIKit.UITraitCollection? = nil) -> UIKit.UIColor? {
      return UIKit.UIColor(resource: R.color.accentColor, compatibleWith: traitCollection)
    }
    #endif

    #if os(watchOS)
    /// `UIColor(named: "AccentColor", bundle: ..., traitCollection: ...)`
    @available(watchOSApplicationExtension 4.0, *)
    static func accentColor(_: Void = ()) -> UIKit.UIColor? {
      return UIKit.UIColor(named: R.color.accentColor.name)
    }
    #endif

    fileprivate init() {}
  }

  /// This `R.image` struct is generated, and contains static references to 1 images.
  struct image {
    /// Image `burger`.
    static let burger = Rswift.ImageResource(bundle: R.hostingBundle, name: "burger")

    #if os(iOS) || os(tvOS)
    /// `UIImage(named: "burger", bundle: ..., traitCollection: ...)`
    static func burger(compatibleWith traitCollection: UIKit.UITraitCollection? = nil) -> UIKit.UIImage? {
      return UIKit.UIImage(resource: R.image.burger, compatibleWith: traitCollection)
    }
    #endif

    fileprivate init() {}
  }

  /// This `R.nib` struct is generated, and contains static references to 4 nibs.
  struct nib {
    /// Nib `HeaderView`.
    static let headerView = _R.nib._HeaderView()
    /// Nib `IngredientsTableViewCell`.
    static let ingredientsTableViewCell = _R.nib._IngredientsTableViewCell()
    /// Nib `RecipeTableViewCell`.
    static let recipeTableViewCell = _R.nib._RecipeTableViewCell()
    /// Nib `SelectRecipeTableViewCell`.
    static let selectRecipeTableViewCell = _R.nib._SelectRecipeTableViewCell()

    #if os(iOS) || os(tvOS)
    /// `UINib(name: "HeaderView", in: bundle)`
    @available(*, deprecated, message: "Use UINib(resource: R.nib.headerView) instead")
    static func headerView(_: Void = ()) -> UIKit.UINib {
      return UIKit.UINib(resource: R.nib.headerView)
    }
    #endif

    #if os(iOS) || os(tvOS)
    /// `UINib(name: "IngredientsTableViewCell", in: bundle)`
    @available(*, deprecated, message: "Use UINib(resource: R.nib.ingredientsTableViewCell) instead")
    static func ingredientsTableViewCell(_: Void = ()) -> UIKit.UINib {
      return UIKit.UINib(resource: R.nib.ingredientsTableViewCell)
    }
    #endif

    #if os(iOS) || os(tvOS)
    /// `UINib(name: "RecipeTableViewCell", in: bundle)`
    @available(*, deprecated, message: "Use UINib(resource: R.nib.recipeTableViewCell) instead")
    static func recipeTableViewCell(_: Void = ()) -> UIKit.UINib {
      return UIKit.UINib(resource: R.nib.recipeTableViewCell)
    }
    #endif

    #if os(iOS) || os(tvOS)
    /// `UINib(name: "SelectRecipeTableViewCell", in: bundle)`
    @available(*, deprecated, message: "Use UINib(resource: R.nib.selectRecipeTableViewCell) instead")
    static func selectRecipeTableViewCell(_: Void = ()) -> UIKit.UINib {
      return UIKit.UINib(resource: R.nib.selectRecipeTableViewCell)
    }
    #endif

    static func headerView(owner ownerOrNil: AnyObject?, options optionsOrNil: [UINib.OptionsKey : Any]? = nil) -> HeaderView? {
      return R.nib.headerView.instantiate(withOwner: ownerOrNil, options: optionsOrNil)[0] as? HeaderView
    }

    static func ingredientsTableViewCell(owner ownerOrNil: AnyObject?, options optionsOrNil: [UINib.OptionsKey : Any]? = nil) -> IngredientsTableViewCell? {
      return R.nib.ingredientsTableViewCell.instantiate(withOwner: ownerOrNil, options: optionsOrNil)[0] as? IngredientsTableViewCell
    }

    static func recipeTableViewCell(owner ownerOrNil: AnyObject?, options optionsOrNil: [UINib.OptionsKey : Any]? = nil) -> RecipeTableViewCell? {
      return R.nib.recipeTableViewCell.instantiate(withOwner: ownerOrNil, options: optionsOrNil)[0] as? RecipeTableViewCell
    }

    static func selectRecipeTableViewCell(owner ownerOrNil: AnyObject?, options optionsOrNil: [UINib.OptionsKey : Any]? = nil) -> SelectRecipeTableViewCell? {
      return R.nib.selectRecipeTableViewCell.instantiate(withOwner: ownerOrNil, options: optionsOrNil)[0] as? SelectRecipeTableViewCell
    }

    fileprivate init() {}
  }

  /// This `R.reuseIdentifier` struct is generated, and contains static references to 3 reuse identifiers.
  struct reuseIdentifier {
    /// Reuse identifier `IngredientsTableViewCell`.
    static let ingredientsTableViewCell: Rswift.ReuseIdentifier<IngredientsTableViewCell> = Rswift.ReuseIdentifier(identifier: "IngredientsTableViewCell")
    /// Reuse identifier `RecipeTableViewCell`.
    static let recipeTableViewCell: Rswift.ReuseIdentifier<RecipeTableViewCell> = Rswift.ReuseIdentifier(identifier: "RecipeTableViewCell")
    /// Reuse identifier `SelectRecipeTableViewCell`.
    static let selectRecipeTableViewCell: Rswift.ReuseIdentifier<SelectRecipeTableViewCell> = Rswift.ReuseIdentifier(identifier: "SelectRecipeTableViewCell")

    fileprivate init() {}
  }

  fileprivate struct intern: Rswift.Validatable {
    fileprivate static func validate() throws {
      try _R.validate()
    }

    fileprivate init() {}
  }

  fileprivate class Class {}

  fileprivate init() {}
}

struct _R: Rswift.Validatable {
  static func validate() throws {
    #if os(iOS) || os(tvOS)
    try nib.validate()
    #endif
    #if os(iOS) || os(tvOS)
    try storyboard.validate()
    #endif
  }

  #if os(iOS) || os(tvOS)
  struct nib: Rswift.Validatable {
    static func validate() throws {
      try _RecipeTableViewCell.validate()
      try _SelectRecipeTableViewCell.validate()
    }

    struct _HeaderView: Rswift.NibResourceType {
      let bundle = R.hostingBundle
      let name = "HeaderView"

      func firstView(owner ownerOrNil: AnyObject?, options optionsOrNil: [UINib.OptionsKey : Any]? = nil) -> HeaderView? {
        return instantiate(withOwner: ownerOrNil, options: optionsOrNil)[0] as? HeaderView
      }

      fileprivate init() {}
    }

    struct _IngredientsTableViewCell: Rswift.NibResourceType, Rswift.ReuseIdentifierType {
      typealias ReusableType = IngredientsTableViewCell

      let bundle = R.hostingBundle
      let identifier = "IngredientsTableViewCell"
      let name = "IngredientsTableViewCell"

      func firstView(owner ownerOrNil: AnyObject?, options optionsOrNil: [UINib.OptionsKey : Any]? = nil) -> IngredientsTableViewCell? {
        return instantiate(withOwner: ownerOrNil, options: optionsOrNil)[0] as? IngredientsTableViewCell
      }

      fileprivate init() {}
    }

    struct _RecipeTableViewCell: Rswift.NibResourceType, Rswift.ReuseIdentifierType, Rswift.Validatable {
      typealias ReusableType = RecipeTableViewCell

      let bundle = R.hostingBundle
      let identifier = "RecipeTableViewCell"
      let name = "RecipeTableViewCell"

      func firstView(owner ownerOrNil: AnyObject?, options optionsOrNil: [UINib.OptionsKey : Any]? = nil) -> RecipeTableViewCell? {
        return instantiate(withOwner: ownerOrNil, options: optionsOrNil)[0] as? RecipeTableViewCell
      }

      static func validate() throws {
        if #available(iOS 13.0, *) { if UIKit.UIImage(systemName: "clock") == nil { throw Rswift.ValidationError(description: "[R.swift] System image named 'clock' is used in nib 'RecipeTableViewCell', but couldn't be loaded.") } }
        if #available(iOS 11.0, tvOS 11.0, *) {
        }
      }

      fileprivate init() {}
    }

    struct _SelectRecipeTableViewCell: Rswift.NibResourceType, Rswift.ReuseIdentifierType, Rswift.Validatable {
      typealias ReusableType = SelectRecipeTableViewCell

      let bundle = R.hostingBundle
      let identifier = "SelectRecipeTableViewCell"
      let name = "SelectRecipeTableViewCell"

      func firstView(owner ownerOrNil: AnyObject?, options optionsOrNil: [UINib.OptionsKey : Any]? = nil) -> SelectRecipeTableViewCell? {
        return instantiate(withOwner: ownerOrNil, options: optionsOrNil)[0] as? SelectRecipeTableViewCell
      }

      static func validate() throws {
        if #available(iOS 13.0, *) { if UIKit.UIImage(systemName: "pencil") == nil { throw Rswift.ValidationError(description: "[R.swift] System image named 'pencil' is used in nib 'SelectRecipeTableViewCell', but couldn't be loaded.") } }
        if #available(iOS 11.0, tvOS 11.0, *) {
        }
      }

      fileprivate init() {}
    }

    fileprivate init() {}
  }
  #endif

  #if os(iOS) || os(tvOS)
  struct storyboard: Rswift.Validatable {
    static func validate() throws {
      #if os(iOS) || os(tvOS)
      try launchScreen.validate()
      #endif
      #if os(iOS) || os(tvOS)
      try main.validate()
      #endif
    }

    #if os(iOS) || os(tvOS)
    struct launchScreen: Rswift.StoryboardResourceWithInitialControllerType, Rswift.Validatable {
      typealias InitialController = UIKit.UIViewController

      let bundle = R.hostingBundle
      let name = "LaunchScreen"

      static func validate() throws {
        if #available(iOS 11.0, tvOS 11.0, *) {
        }
      }

      fileprivate init() {}
    }
    #endif

    #if os(iOS) || os(tvOS)
    struct main: Rswift.StoryboardResourceType, Rswift.Validatable {
      let bundle = R.hostingBundle
      let firstScreenViewController = StoryboardViewControllerResource<FirstScreenViewController>(identifier: "FirstScreenViewController")
      let name = "Main"
      let recipeInformationViewController = StoryboardViewControllerResource<RecipeInformationViewController>(identifier: "RecipeInformationViewController")

      func firstScreenViewController(_: Void = ()) -> FirstScreenViewController? {
        return UIKit.UIStoryboard(resource: self).instantiateViewController(withResource: firstScreenViewController)
      }

      func recipeInformationViewController(_: Void = ()) -> RecipeInformationViewController? {
        return UIKit.UIStoryboard(resource: self).instantiateViewController(withResource: recipeInformationViewController)
      }

      static func validate() throws {
        if #available(iOS 11.0, tvOS 11.0, *) {
        }
        if _R.storyboard.main().firstScreenViewController() == nil { throw Rswift.ValidationError(description:"[R.swift] ViewController with identifier 'firstScreenViewController' could not be loaded from storyboard 'Main' as 'FirstScreenViewController'.") }
        if _R.storyboard.main().recipeInformationViewController() == nil { throw Rswift.ValidationError(description:"[R.swift] ViewController with identifier 'recipeInformationViewController' could not be loaded from storyboard 'Main' as 'RecipeInformationViewController'.") }
      }

      fileprivate init() {}
    }
    #endif

    fileprivate init() {}
  }
  #endif

  fileprivate init() {}
}
